MAP_WIDTH = 31
MAP_HEIGHT = 23
FEEDBACK_SPEED = 1024

require "lua/terrain"
require "lua/objects"

function worldData()
	Objects_MakeString()
	return tostring(Terrain) .. "|" .. table.concat(Objects_String,"!")
end

function yield()
	coroutine.yield( worldData() )
end

function generate()
	setOverlay("")
	setName("Work in Progress")
	
	--log = io.open("C:\\ngen.txt", "w")
	Terrain_Phase1()
	Terrain_Phase2()
	Terrain_Phase3()
	Terrain_Phase4()
	Terrain_Phase5()
	
	Objects_Phase1()
	Objects_Phase2()
	Objects_Phase3()
	Objects_Phase4()
	Objects_Phase5()
	Objects_Phase6()
	Objects_Phase7()
	Objects_Phase8()
	
	table.insert(Objects, table.remove(Objects, 2)) -- move exit to end
	
	setName("Random Map " .. math.random(1, 1000000))
	setAuthor("Corsix Generator")
	
	return worldData()
end
